using System;
using UnityEngine;

namespace Syntriax.Modules.Trigger
{
    public class Trigger : MonoBehaviour, ITrigger
    {
        public Action<bool> OnTriggered { get; set; } = null;

        private bool _isTrigerred = false;
        public bool IsTrigerred
        {
            get => _isTrigerred;
            protected set
            {
                bool oldValue = _isTrigerred;

                _isTrigerred = value;

                if (oldValue != value)
                    OnTriggered?.Invoke(value);
            }
        }
    }
}
